## aHR0cHM6Ly9naXRodWIuY29tL2tkbTkvYXhlL2FyY2hpdmUvcmVmcy90YWdzLzAuMi42LnRhci5neg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT(axe C)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")

# Cmake options
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
ENABLE_TESTING()

IF (NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release)
ENDIF()

IF (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/version")
	FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" AXE_VERSION)
ELSE()
	# git describe as versioning
	EXECUTE_PROCESS(COMMAND git describe
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE AXE_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

MESSAGE(STATUS "${CMAKE_BUILD_TYPE} build of axe version: ${AXE_VERSION}")

###############################
## Find Packages and Headers ##
###############################

# Done by libqes' CML.txt

##########################
## Set Compiler Options ##
##########################

IF (CMAKE_COMPILER_IS_GNUCC)
        SET(AXEWRN "${AXEWRN} -Woverride-init -Wnormalized=id -Wlogical-op")
        EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        IF (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
                SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdiagnostics-color=always")
        ENDIF()
ENDIF()

# Set CFLAGS
SET(AXEWRN "${AXEWRN} -fstack-protector-all -Wstack-protector -Wfloat-equal")
SET(AXEWRN "${AXEWRN} -Wundef -Wpointer-arith -Wstrict-prototypes")
SET(AXEWRN "${AXEWRN} -Wmissing-prototypes -Wwrite-strings -Wredundant-decls")
SET(AXEWRN "${AXEWRN} -Wchar-subscripts -Wcomment -Wformat=2 -Wwrite-strings")
SET(AXEWRN "${AXEWRN} -Wmissing-declarations -Wredundant-decls -Wnested-externs")
SET(AXEWRN "${AXEWRN} -Wbad-function-cast -Wswitch-enum -Winit-self")
SET(AXEWRN "${AXEWRN} -Wmissing-field-initializers -Wdeclaration-after-statement")
SET(AXEWRN "${AXEWRN} -Wold-style-definition -Waddress -Wmissing-noreturn ")
SET(AXEWRN "${AXEWRN} -Wstrict-overflow=1 -Wextra -Warray-bounds -Wall -D_FORTIFY_SOURCE=2")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${AXEWRN}")

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src
                    ${CMAKE_SOURCE_DIR}/src/datrie
                    ${CMAKE_SOURCE_DIR}/src/libqes/src
                    ${CMAKE_SOURCE_DIR}/src/gsl)
LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lib)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/src/axe_config.h.in
               ${CMAKE_BINARY_DIR}/axe_config.h)

ADD_SUBDIRECTORY(docs)
ADD_SUBDIRECTORY(tests)
ADD_SUBDIRECTORY(src)
SET(LIBQES_AS_SUBMODULE True)  # stop libqes installing itself
ADD_SUBDIRECTORY(src/libqes)

=== docs/CMakeLists.txt ===
FIND_PROGRAM(SPHINXBUILD sphinx-build)
IF(SPHINXBUILD)
    SET(ALLSPHINXOPTS -q -D latex_paper_size=a4)
    ADD_CUSTOM_TARGET(doc_html
        COMMAND ${SPHINXBUILD} -b html ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/html
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_onehtml
        COMMAND ${SPHINXBUILD} -b singlehtml ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/single
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_man
        COMMAND ${SPHINXBUILD} -b man ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/man
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_clean
	COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_BINARY_DIR}/doc"
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc ALL DEPENDS doc_man doc_onehtml)
    INSTALL(FILES ${CMAKE_BINARY_DIR}/doc/man/axe.1 DESTINATION "share/man/man1")
    SET_DIRECTORY_PROPERTIES(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES doc/)
ENDIF()

=== src/CMakeLists.txt ===
# Axe library (libaxe.a)
FILE(GLOB DATRIE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/datrie/*.c)
FILE(GLOB GSL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/gsl/*.c)
SET(AXELIB_SRCS ${DATRIE_SRCS} ${GSL_SRCS} axe.c)

ADD_LIBRARY(axelib STATIC ${AXELIB_SRCS})
TARGET_LINK_LIBRARIES(axelib qes_static)
SET_TARGET_PROPERTIES(axelib PROPERTIES OUTPUT_NAME axe)

# Executable
ADD_EXECUTABLE(axe main.c)
TARGET_LINK_LIBRARIES(axe ${AXE_DEPENDS_LIBS} axelib)
INSTALL(TARGETS axe DESTINATION "bin")

=== tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/tinytest)

ADD_EXECUTABLE(test_axe test.c ${CMAKE_CURRENT_SOURCE_DIR}/tinytest/tinytest.c test_libaxe.c)
TARGET_LINK_LIBRARIES(test_axe ${AXE_DEPENDS_LIBRARIES} axelib)

# Copy test files over to bin dir & make output
ADD_CUSTOM_TARGET(setup_tests ALL
	COMMAND ${CMAKE_COMMAND} -E copy_directory
		   ${CMAKE_CURRENT_SOURCE_DIR}/data
                   ${CMAKE_BINARY_DIR}/data
	COMMAND ${CMAKE_COMMAND} -E copy
                   ${CMAKE_CURRENT_SOURCE_DIR}/axe_integration.py
                   ${CMAKE_BINARY_DIR}/bin
	COMMAND ${CMAKE_COMMAND} -E make_directory
                   ${CMAKE_BINARY_DIR}/out)
ADD_DEPENDENCIES(test_axe setup_tests)

ADD_TEST(NAME "UnitTests" COMMAND test_axe)
SET(COVERAGE_CMD test_axe)
SET(COVERAGE_OUT "${CMAKE_BINARY_DIR}/coverage_html")

ADD_TEST(NAME "IntegrationTests" COMMAND python
         ${CMAKE_BINARY_DIR}/bin/axe_integration.py
         ${CMAKE_BINARY_DIR})

IF (CMAKE_BUILD_TYPE STREQUAL "Coverage")
	FIND_PROGRAM( GCOV_PATH gcov )
	FIND_PROGRAM( LCOV_PATH lcov )
	FIND_PROGRAM( GENHTML_PATH genhtml )
	FIND_PROGRAM( GCOVR_PATH gcovr PATHS ${CMAKE_SOURCE_DIR}/tests)

	SET(CMAKE_C_FLAGS_COVERAGE
	    "${CMAKE_C_FLAGS_DEBUG} -g -O0 --coverage -fprofile-arcs -ftest-coverage"
	    CACHE STRING "Flags used by the C compiler during coverage builds."
	    FORCE)
	SET(CMAKE_EXE_LINKER_FLAGS_COVERAGE
	    ""
	    CACHE STRING "Flags used for linking binaries during coverage builds."
	    FORCE)
	SET(CMAKE_SHARED_LINKER_FLAGS_COVERAGE
	    ""
	    CACHE STRING "Flags used by the shared libraries linker during coverage builds."
	    FORCE)
	MARK_AS_ADVANCED(
	    CMAKE_C_FLAGS_COVERAGE
	    CMAKE_EXE_LINKER_FLAGS_COVERAGE
	    CMAKE_SHARED_LINKER_FLAGS_COVERAGE )

	IF(NOT GCOV_PATH)
		MESSAGE(FATAL_ERROR "gcov not found! Aborting...")
	ENDIF() # NOT GCOV_PATH
	IF(NOT LCOV_PATH)
		MESSAGE(FATAL_ERROR "lcov not found! Aborting...")
	ENDIF() # NOT LCOV_PATH
	IF(NOT GENHTML_PATH)
		MESSAGE(FATAL_ERROR "genhtml not found! Aborting...")
	ENDIF() # NOT GENHTML_PATH
	IF(NOT CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_GNUCXX)
		# Clang version 3.0.0 and greater now supports gcov as well.
		MESSAGE(WARNING "Compiler is not GNU gcc! Clang Version 3.0.0 and greater supports gcov as well, but older versions don't.")
		IF(NOT "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" AND NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
			MESSAGE(FATAL_ERROR "Compiler is not GNU gcc! Aborting...")
		ENDIF()
	ENDIF() # NOT CMAKE_COMPILER_IS_GNUCXX

	# Setup target
	ADD_CUSTOM_TARGET(coverage
		# Cleanup lcov
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory  ${CMAKE_BINARY_DIR}/src --zerocounters

		# Run tests
		COMMAND ${COVERAGE_CMD}

		# Capturing lcov counters and generating report
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory ${CMAKE_BINARY_DIR}/src --capture --output-file ${COVERAGE_OUT}.info
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/kmlib/*
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/datrie/*
		COMMAND ${GENHTML_PATH} --branch-coverage -o ${COVERAGE_OUT} ${COVERAGE_OUT}.info
		COMMAND ${CMAKE_COMMAND} -E remove ${COVERAGE_OUT}.info

		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Resetting code coverage counters to zero.\nProcessing code coverage counters and generating report."
	)

	# Show info where to find the report
	ADD_CUSTOM_COMMAND(TARGET coverage POST_BUILD
		COMMAND ;
		COMMENT "Open ${COVERAGE_OUT}/index.html in your browser to view the coverage report."
	)

ENDIF() # build type coverage

=== debian/changelog ===
axe-demuxer (0.2.1-1) UNRELEASED; urgency=medium

  * Initial debian release. (Closes: #XXXXX)

 -- Kevin Murray <spam@kdmurray.id.au>  Mon, 26 Jan 2015 11:00:07 +1100

=== debian/control ===
Source: axe-demuxer
Maintainer: Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9),
	       cmake,
               zlib1g-dev
Homepage: https://github.com/kdmurray91/axe

Package: axe-demuxer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Trie-based DNA sequencing read demultiplexer
 AXE very rapidly selects the optimal barcode present in a sequence read, even
 in the presence of sequencing errors. The algorithm is able to handle
 combinatorial barcoding, barcodes of differing length, and several mismatches
 per barcode.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake
